#include "dr26.hpp"
#include "NoDataAvailableException.hpp"
#include "esp_log.h"
#include "f_deep_sleep.hpp"
#include <Arduino.h>
#include <drs26.hpp>
#include <ina219.hpp>
#include <scd30.hpp>
#include "ESPNow.hpp"
// #include "esp32-hal-log.h"
static const std::string TAG = "MAIN";

ForteDRS26 drs26;
//
//ForteDR26 dr26_channel0;
//ForteDR26 dr26_channel1;

void setup()
{
	Serial.begin(115200);

	DeepSleep::print_wakeup_reason();
	DeepSleep::bootCount++;
	ESP_LOGD(TAG.c_str(), "Boot number: %d", DeepSleep::bootCount);


//	dr26_channel1.setup();
//	dr26_channel0.setChannel(0);
//	dr26_channel1.setChannel(1);
	drs26.setup();
	espnow_setup();
	//	log_e("Setup complete.");
}

void loop()
{
//
//Serial.println("***********************1-DRS26**********************************");
//Serial.println(dr26_channel0.readData(),5);
//Serial.println("***********************2-DRS26**********************************");
//Serial.println(dr26_channel1.readData(),5);

	try {

		auto messages = drs26.buildMessages();

		for (const Message &message : messages) {
			if(message.send() != ESP_OK){
				RtcMemory::store(message.getMessageAsMinifiedJsonString());
			}
			delay(5000);
			if(!was_msg_received()){
				RtcMemory::store(message.getMessageAsMinifiedJsonString());
			}
		}

	} catch (const NoDataAvailableException &e) {
		std::cerr << e.what() << '\n';
	}

	Serial.print("This device: ");
	Serial.println("\n");

	delay(5000);
	DeepSleep::deep_sleep(5);
}
