#ifndef _SCD30
#define _SCD30

#include "ForteSensor.hpp"
#include "Message.hpp"
#include "NoDataAvailableException.hpp"
#include "Pinout.hpp"
#include "esp_log.h"
#include <SparkFun_SCD30_Arduino_Library.h>
#include <Wire.h>

struct out_data_scd30 {
	float C02;
	float Temperature;
	float Humidity;
};

class ForteSCD30 : public ForteSensor<out_data_scd30> {
  public:
	void setup() override;
	out_data_scd30 readData() override;
	std::list<Message> buildMessages() override;
	[[nodiscard]] SensorInformation getSensorInformation() const override;

  private:
	SCD30 airSensor;
	out_data_scd30 data;
	const SensorInformation sensorInformation{"SCD30", Protocol::I2C};
};

#endif