#include "rs485.hpp"
// RS485 control
#define RXPin 0 // Serial Receive pin
#define TXPin 1 // Serial Transmit pin

//Configer sensors
SoftwareSerial RS485Serial1(0, 1);
SolarRadiationSensor solarSensor1(&RS485Serial1, 1);
RainGaugeSensor rainGauge1 = RainGaugeSensor(&RS485Serial1, 2);               //Give 2 Sensor Adress 2
SoilMoistureSensor soilSensor31 = SoilMoistureSensor(&RS485Serial1, 3);       //.....
SoilMoistureSensor soilSensor41 = SoilMoistureSensor(&RS485Serial1, 4);
SoilMoistureSensor soilSensor51 = SoilMoistureSensor(&RS485Serial1, 5);

void Forte_RS485::setup(){
     // configure the pins to be output only
    pinMode(SERIAL_COMMUNICATION_CONTROL_PIN, OUTPUT);
    gpio_set_direction(GPIO_NUM_3, GPIO_MODE_OUTPUT);
     // Set data rates: Serial baud rate has to be WAY HIGHER than RS485Serial!
    Serial.begin(115200);
    RS485Serial1.begin(4800);   
}

out_data_rs485 Forte_RS485::read_data(){
    data.solarRadiation=solarSensor1.getSolarRadiation();
    data.moisture=soilSensor41.getMoisture();
    data.moisture_temperature=soilSensor41.getMoistureTemp();
    data.precipitation=rainGauge1.getInstantaneousPrecipitation();
    return data;
}
