#ifndef _RS485
#define _RS485

#include "SPI.h"
// RTC (I2C)
#include "RTClib.h"
#include "forte_sensor.hpp"
#include "SentecSensors.h"

#define SERIAL_COMMUNICATION_CONTROL_PIN 3

// power control
#define TransistorPin 10 // controls the transistor for power consumption (on/off)

struct out_data_rs485{
    word solarRadiation;
    float moisture;
    word moisture_temperature;
    word precipitation;
};


class Forte_RS485 : public Forte_Sensor<out_data_rs485> {

    public:
	    void setup();
	    out_data_rs485 read_data();
    
    private:
     out_data_rs485 data;
};

#endif 