#include <Arduino.h>
#include <scd30.hpp>
#include <ina219.hpp>
#include <drs26.hpp>

Forte_SCD30 scd30;
Forte_INA219 ina219;
Forte_DRS26 drs26;


void setup() {
  Serial.begin(9600);
  ina219.setup();
  drs26.setup();
  
}

void loop() {
  
//***********************************************************DATA for ins219**************************

  out_data_ina219* data_ina219;
  data_ina219 = ina219.read_data();
  Serial.println("******************************INA219********************Power--Consumption**********************************");
  if(data_ina219==0)
  {
  Serial.println("Waiting for data!");
  Serial.println();
  }
  else{
        Serial.print("Shunt Voltage [mV]: "); Serial.println(data_ina219->shuntVoltage_mV);
        Serial.print("Bus Voltage [V]: "); Serial.println(data_ina219->busVoltage_V);
        Serial.print("Load Voltage [V]: "); Serial.println(data_ina219->loadVoltage_V);
        Serial.print("Current[mA]: "); Serial.println(data_ina219->current_mA);
        Serial.print("Bus Power [mW]: "); Serial.println(data_ina219->power_mW);
        data_ina219->ina219_overflow== false ? Serial.println("Values OK - no overflow") : Serial.println("Overflow! Choose higher PGAIN");
        Serial.println();
    }
  delay(1000);


  out_data_drs26* data;
  drs26.read_data();
  
  data = drs26.read_data();
  Serial.println("******************************DRS26********************Tree-size**********************************");
  if(data==0)
  {
  Serial.println("Waiting for data!");
  Serial.println();
  }
  else{
        Serial.print("Sensor ID "); Serial.println(data->id);
        Serial.print("Cicumfence "); Serial.println(data->circumference);
        Serial.print("Temperature "); Serial.println(data->temperatur);
        Serial.println();
    }
  delay(1000);

}

