#ifndef _INA219
#define _INA219

#include "Message.hpp"
#include "Wire.h"
#include "forte_sensor.hpp"
#include "pinout.hpp"
#include <Adafruit_INA219.h>
#include <NoDataAvailableException.hpp>
#include "NoDataAvailableException.hpp"

struct out_data_ina219 {
	float shuntVoltage_mV = 0.0;
	float loadVoltage_V = 0.0;
	float busVoltage_V = 0.0;
	float current_mA = 0.0;
	float power_mW = 0.0;
	bool ina219_overflow = false;
};

class Forte_INA219 : public Forte_Sensor<out_data_ina219> {
  public:
	void setup();
	out_data_ina219 read_data();
	Message build_message();

  private:
	Adafruit_INA219 ina219;
	out_data_ina219 data;
};

#endif