#include <Arduino.h>
#include <Wire.h>
#include <dr26.hpp>
#include <ina219.hpp>
#include "esp_debug_helpers.h"

Adafruit_ADS1115 adss;

Forte_DR26 dr26;
Forte_INA219 ina219;

void setup()
{
	Serial.begin(9600);
   Wire.begin(6, 7);
    adss.setGain(GAIN_ONE);
    adss.begin() ?  Serial.println("ADS initialized") : Serial.println("failed to initialize ADS");
    delay(100);
	dr26.setup();
	ina219.setup();
	
}
int x =0;

void loop()
{
   Serial.println("******************************DR26-Analog********************Tree-Size**********************************");
   float data_drs26=-1;
   try
   {
      data_drs26=dr26.read_data();
      Serial.print("dr26: ");
	   Serial.println(data_drs26);
   }
   catch(NoDataAvailableException& e){
	Serial.println("No Sensor aviable");
   }
   
	out_data_ina219 data_ina219;
	Serial.println("******************************INA219********************Power--Consumption**********************************");
   try{
		   data_ina219=ina219.read_data();
   		Serial.print("Shunt Voltage [mV]: "); Serial.println(data_ina219.shuntVoltage_mV);
        Serial.print("Bus Voltage [V]: "); Serial.println(data_ina219.busVoltage_V);
        Serial.print("Load Voltage [V]: "); Serial.println(data_ina219.loadVoltage_V);
        Serial.print("Current[mA]: "); Serial.println(data_ina219.current_mA);
        Serial.print("Bus Power [mW]: "); Serial.println(data_ina219.power_mW);
        data_ina219.ina219_overflow== false ? Serial.println("Values OK - no overflow") : Serial.println("Overflow! Choose higher PGAIN");
        Serial.println();
   }

   catch(NoDataAvailableException& e){
	   Serial.println("No Sensor aviable");
   }
 
  // Serial.println("Free Heap:"); Keep trach of the free stack -> momery leak can cause stack overflow 
  // Serial.println(esp_get_free_heap_size());
	delay(4000);
}
