#include "ina219.hpp"


void Forte_INA219 :: setup(){
    Wire.begin(I2C_SDA, I2C_SCL);
     if(!ina219.init()){
        // Sensor init went wrong
        return;
    } 
}

out_data_ina219* Forte_INA219  :: read_data(){
    if(!ina219.getOverflow())
    {
        data.shuntVoltage_mV = ina219.getShuntVoltage_mV();
        data.busVoltage_V= ina219.getBusVoltage_V();
        data.current_mA= ina219.getCurrent_mA();
        data.power_mW= ina219.getBusPower();
        data.loadVoltage_V = data.busVoltage_V + (data.shuntVoltage_mV/1000);
        data.ina219_overflow=ina219.getOverflow();
        
        return &data;
    }
    else
        return 0;
}

void Forte_INA219 :: print(out_data_ina219* data_ina219){
  Serial.println("******************************INA219********************Power-Consumption**********************************");
  if(data_ina219==0)
  {
  Serial.println("Waiting for data!");
  Serial.println();
  }
  else{
        Serial.print("Shunt Voltage [mV]: "); Serial.println(data_ina219->shuntVoltage_mV);
        Serial.print("Bus Voltage [V]: "); Serial.println(data_ina219->busVoltage_V);
        Serial.print("Load Voltage [V]: "); Serial.println(data_ina219->loadVoltage_V);
        Serial.print("Current[mA]: "); Serial.println(data_ina219->current_mA);
        Serial.print("Bus Power [mW]: "); Serial.println(data_ina219->power_mW);
        data_ina219->ina219_overflow== false ? Serial.println("Values OK - no overflow") : Serial.println("Overflow! Choose higher PGAIN");
        Serial.println();
    }
  delay(1000);
}