#ifndef _ESPNOW
#define _ESPNOW

#define NUM_SENSORS 10
//packing the struct without padding, makes reading it on the fipy easier
#pragma pack(1)

// having the data be a struct of basic types makes sending easier,
// otherwise we would have to serialize the data before sending
typedef struct data_struct{
    int identifiers[NUM_SENSORS];
    float values[NUM_SENSORS];
    int amountData;
    long timestamp; //maybe make this array
}data_struct;

// Format of the message sent from host to client
// if more things are sent from the host the name might not be accurate anymore
typedef struct config{
    uint8_t host[6];
    long time_millis;
}config;

class Message{
    public:
        Message();
        Message(data_struct old_data);
        // ~Message();
        void add_data(float value, int identifier);
        esp_err_t send();

    private:
        data_struct data;
        uint8_t recipient[6];

};

esp_err_t espnow_setup();
bool is_host_defined();

#endif