#include <Arduino.h>
#include <scd30.hpp>
#include <ina219.hpp>
#include <drs26.hpp>
#include "espnow.hpp"
#include "ram_caching.hpp"
#include <stdio.h>
#include <f_deep_sleep.h>

Forte_SCD30 scd30;
Forte_INA219 ina219;
Forte_DRS26 drs26;


void setup() {
  Serial.begin(9600);
  Serial.println();
  Serial.println("Weak up from deep sleep");
  ina219.setup();
  drs26.setup();
  esp_err_t result = espnow_setup();
}



void loop() {

//*****Data from the Sensor INA219
  out_data_ina219* data_ina219;
  data_ina219 = ina219.read_data();
  ina219.print(data_ina219);

//*****Data from the Sensor DRS26
  out_data_drs26* data_drs26;
  data_drs26 = drs26.read_data();
  drs26.print(data_drs26);


  //temperatur  0
  //cicumfence  1

  //load voltage 2
  //crrent       3
  Message* new_data = new Message();
  new_data->add_data(data_drs26->temperatur, 0);
  new_data->add_data(data_drs26->circumference, 1);
  new_data->add_data(data_ina219->loadVoltage_V, 2);
  new_data->add_data(data_ina219->current_mA,3);
  new_data->send();
  delete new_data;


  Serial.println("Going to sleep");
  deep_sleep(5);


}

