import network

# start the ESP in AP mode
ap = network.WLAN(network.AP_IF)
ap.active(True)
ap.config(essid='micropython', password=b"ThisIsAPassword", channel=11,
          authmode=network.AUTH_WPA_WPA2_PSK)  # Set up an access point
print('network config:', ap.ifconfig())
print('network status:', ap.status())

import uasyncio
# to install microdot, see https://git.uibk.ac.at/informatik/qe/forte/forte/-/wikis/Microdot-Installation
from lib.src.microdot_asyncio import Microdot

# setup webserver
app = Microdot()

# add a route
@app.post('/')
async def hello(request):
    with open("test.txt", "a") as f:
        f.write("request " + str(request.body) + "\n")
        print("request")
    return 'Hello world'


def start_server():
    print('Starting microdot app')
    try:
        app.run(port=80)
    except:
        app.shutdown()


start_server()

