import network
from network import ESPNOW
import time
from lib.rtc_time import RTCTime
import struct

w = network.WLAN()
self_mac, sta = w.mac()
peer_list = []

class Forte_ESPNOW:
    def __init__(self):
        ESPNOW.init()
        ESPNOW.on_recv(espnow_recv)
    
    def add_peer(mac):
        peer_list.append(ESPNOW.add_peer(mac))

def espnow_respond(mac):
    msg = struct.pack("<6sl", self_mac, time.time())
    print(int(time.time()))

    ESPNOW.send(mac, msg)
    print("response sent")

def espnow_recv(result):
    print("message recv")
    mac, peer, msg = result

    data = bytes_to_data(msg)
    try:
        print("amount data: " + str(data["amountData"]))
    #     print(data["timestamp"])
    #     print(data["data"])

    except Exception as error:
        print(error)

    if(peer not in peer_list):
        Forte_ESPNOW.add_peer(mac)
    
    espnow_respond(mac)

def bytes_to_data(msg):
    # turn bytes from message into 22-tuple of integers(identifiers), floats(values), integer(amount) and long(timestamp)
    data = struct.unpack("<10i10fil", bytes(msg))
    amountData = data[20]
    timestamp = data[21]
    identifiers = data[0:amountData]
    values = data[10 : (10 + amountData)]
    return {
        "amountData": amountData,
        "timestamp": timestamp,
        "data": dict(zip(identifiers, values)),
    }


