# main.py -- put your code here!
from network import WLAN
from network import ESPNOW
import binascii
import struct
from time import sleep
from lib.server_transfer import DataTransferWiFi
from lib.rtc_time import RTCTime


def bytes_to_data(msg):
    # turn bytes from message into 22-tuple of integers(identifiers), floats(values), integer(amount) and long(timestamp)
    data = struct.unpack("<10i10fil", bytes(msg))
    amountData = data[20]
    timestamp = data[21]
    identifiers = data[0:amountData]
    values = data[10 : (10 + amountData)]
    return {
        "amountData": amountData,
        "timestamp": timestamp,
        "data": dict(zip(identifiers, values)),
    }


def espnow_recv(result):
    mac, peer, msg = result

    data = bytes_to_data(msg)
    try:
        print(data["amountData"])
        print(data["timestamp"])
        print(data["data"])
        print(str(binascii.hexlify(mac), "ascii"))

    except Exception as error:
        print(error)


data = DataTransferWiFi()
data.connect("Z", "AbsoluteSandwich")
data.send(
    "airSensors,sensor_id=TLM0201 temperature=73.97038159354763,humidity=35.23103248356096,co=0.4844531056779361 1661175680\nairSensors,sensor_id=TLM0202 temperature=75.30007505999716,humidity=35.65192991869171,co=0.5141876544505826 1661175680\nairSensors,sensor_id=TLM0202 temperature=75.30007505999756,humidity=35.65192991869171,co=0.5141876544505826 1661175680"
)
# data.disconnect()

rtc_time = RTCTime((2014, 5, 1, 4, 13, 0, 0, 0))
# w = WLAN()

# ESPNOW.init()
# p = ESPNOW.add_peer("58cf79043c84")

# ESPNOW.on_recv(espnow_recv)

while True:
    print("...")
    sleep(5)
    print(rtc_time.get_time())
    pass
